searchNodes=[{"doc":"The DimensionalPortal is the 'portal between the two knowledge domains', there is a boundary between the two domains so we need a way to get around it. The Program Knowledge Domain consists of traditional program metadata. Things the host programming language has direct access to, like how long a string is, what fields are in a struct, what value is bound to a variable, what fields a function takes, etc. The AI Knowledge Domain consists of semantic data encoded in a distributed fashion across synaptic weights of a neural network. It is not directly accessible to the host programming language, but can be accessed through the Portal. Note that the same data exists in both domains, but all we can see in the program knowledge domain is things like &quot;foo is a binary string with 587 characters&quot; while in the AI knowledge domain it only knows 'this string is a poem about a cat', The AI isn't good at knowing the string is called 'foo' or how long it is. The program doesn't know what a cat is. There are a feww paths to get around this: PKD -&gt; AIKD: - prompts - source code - machine state - program output AIKD -&gt; PKD: - parsers - instructions to be executed in the VM","ref":"DimensionalPortal.html","title":"DimensionalPortal","type":"module"},{"doc":"Use this when you want to ask the computer to perform a task using natural-language text, one that will have side-effects in the real world. ActionChain wraps a Chain and handles invoking the Chain. It then handles asking for confirmation if the chain is correct.","ref":"LangChain.ActionChain.html","title":"LangChain.ActionChain","type":"module"},{"doc":"TheAccountant is responsible for storing and retrieving usage and pricing reports","ref":"LangChain.Agents.TheAccountant.html","title":"LangChain.Agents.TheAccountant","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LangChain.Agents.TheAccountant.html#child_spec/1","title":"LangChain.Agents.TheAccountant.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"LangChain.Agents.TheAccountant.html#init/1","title":"LangChain.Agents.TheAccountant.init/1","type":"function"},{"doc":"","ref":"LangChain.Agents.TheAccountant.html#post_webhook/2","title":"LangChain.Agents.TheAccountant.post_webhook/2","type":"function"},{"doc":"","ref":"LangChain.Agents.TheAccountant.html#print_to_screen/1","title":"LangChain.Agents.TheAccountant.print_to_screen/1","type":"function"},{"doc":"Query the stored reports by provider and model name","ref":"LangChain.Agents.TheAccountant.html#query/2","title":"LangChain.Agents.TheAccountant.query/2","type":"function"},{"doc":"","ref":"LangChain.Agents.TheAccountant.html#start_link/0","title":"LangChain.Agents.TheAccountant.start_link/0","type":"function"},{"doc":"let's a provider store a price calculation for a run","ref":"LangChain.Agents.TheAccountant.html#store/1","title":"LangChain.Agents.TheAccountant.store/1","type":"function"},{"doc":"An Anchor is a point at the end of a chain where the AI confirms with (hopefully) a human that the result of the chain is 'in alignment' before moving on. AI programming differs from traditional programming because it's inherently hard to predict what it will actually do at run-time. This means that best practice is to anchor your chains so that at runtime a human (or at least a traditional hard-coded computer program) can confirm the AI isn't doing something harmful or WOPRish. Anchors are implemented as a behavior so that you can implement your own anchor, in addition to the CLI and Web anchors in this library. By design they should be predictable and rigorous in terms of output. Don't get creative and try to add natural-language processing to an anchor, because the whole point of an anchor is to eliminate ambiguity about what's going on.","ref":"LangChain.Anchor.Behavior.html","title":"LangChain.Anchor.Behavior","type":"behaviour"},{"doc":"","ref":"LangChain.Anchor.Behavior.html#c:get_confirmation/0","title":"LangChain.Anchor.Behavior.get_confirmation/0","type":"callback"},{"doc":"","ref":"LangChain.Anchor.Behavior.html#c:present_information/2","title":"LangChain.Anchor.Behavior.present_information/2","type":"callback"},{"doc":"An anchor for getting confirmation at run-time from the command line","ref":"LangChain.Anchor.CLI.html","title":"LangChain.Anchor.CLI","type":"module"},{"doc":"returns either :yes or :no depending on the user's input","ref":"LangChain.Anchor.CLI.html#get_confirmation/0","title":"LangChain.Anchor.CLI.get_confirmation/0","type":"function"},{"doc":"Queries don't have side-effects. This presents the information to the user and asks for confirmation if it looks correct","ref":"LangChain.Anchor.CLI.html#present_information/2","title":"LangChain.Anchor.CLI.present_information/2","type":"function"},{"doc":"","ref":"LangChain.AudioModelProtocol.html","title":"LangChain.AudioModelProtocol","type":"protocol"},{"doc":"","ref":"LangChain.AudioModelProtocol.html#speak/2","title":"LangChain.AudioModelProtocol.speak/2","type":"function"},{"doc":"","ref":"LangChain.AudioModelProtocol.html#stream/2","title":"LangChain.AudioModelProtocol.stream/2","type":"function"},{"doc":"","ref":"LangChain.AudioModelProtocol.html#t:t/0","title":"LangChain.AudioModelProtocol.t/0","type":"type"},{"doc":"A GenServer that stores and retrieves memory variables, Memory supports the agent genservers","ref":"LangChain.BaseMemory.html","title":"LangChain.BaseMemory","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LangChain.BaseMemory.html#child_spec/1","title":"LangChain.BaseMemory.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"LangChain.BaseMemory.html#init/1","title":"LangChain.BaseMemory.init/1","type":"function"},{"doc":"A chain of ChainLinks to be processed in order, usually ending in an anchor for user confirmation.","ref":"LangChain.Chain.html","title":"LangChain.Chain","type":"module"},{"doc":"Processes the ChainLinks in the chain and accumulates the output. If the optional anchor parameter is set to true , an anchor step will be added at the end of the chain for user confirmation.","ref":"LangChain.Chain.html#call/4","title":"LangChain.Chain.call/4","type":"function"},{"doc":"Creates a new Chain struct with the given chain_links.","ref":"LangChain.Chain.html#new/1","title":"LangChain.Chain.new/1","type":"function"},{"doc":"an individual chain_link in a language chain when called, a chainlink will fill in and submit an input prompt, then add the entire response to the responses list parse the response with the output_parser store any output","ref":"LangChain.ChainLink.html","title":"LangChain.ChainLink","type":"module"},{"doc":"calls the chain_link, filling in the input prompt and parsing the output","ref":"LangChain.ChainLink.html#call/3","title":"LangChain.ChainLink.call/3","type":"function"},{"doc":"","ref":"LangChain.ChainLink.html#no_parse/2","title":"LangChain.ChainLink.no_parse/2","type":"function"},{"doc":"","ref":"LangChain.ChainLink.html#t:input/0","title":"LangChain.ChainLink.input/0","type":"type"},{"doc":"A Chat is a list of multiple PromptTemplates along with all their input variables","ref":"LangChain.Chat.html","title":"LangChain.Chat","type":"module"},{"doc":"add more PromptTemplates to the Chat","ref":"LangChain.Chat.html#add_prompt_templates/2","title":"LangChain.Chat.add_prompt_templates/2","type":"function"},{"doc":"loops over every prompt and formats it with the values supplied","ref":"LangChain.Chat.html#format/2","title":"LangChain.Chat.format/2","type":"function"},{"doc":"","ref":"LangChain.Chat.html#serialize/1","title":"LangChain.Chat.serialize/1","type":"function"},{"doc":"","ref":"LangChain.Chat.html#to_chat_messages/0","title":"LangChain.Chat.to_chat_messages/0","type":"function"},{"doc":"An Effector is used by a daemon to impact the outside world. By default, an Effector should ask for confirmation before actually impacting anything. Daemons are AIs and should not be trusted to do the right thing without supervision.","ref":"LangChain.Effector.html","title":"LangChain.Effector","type":"module"},{"doc":"Default function to request permission for an action. Returns true to allow the action by default. Override this function with custom permission handling logic.","ref":"LangChain.Effector.html#default_may_i?/2","title":"LangChain.Effector.default_may_i?/2","type":"function"},{"doc":"","ref":"LangChain.Effector.html#default_no!/2","title":"LangChain.Effector.default_no!/2","type":"function"},{"doc":"Default function to execute the action. Override this function with custom action handling logic.","ref":"LangChain.Effector.html#default_yes!/2","title":"LangChain.Effector.default_yes!/2","type":"function"},{"doc":"","ref":"LangChain.ElixirPrompts.DataStructures.html","title":"LangChain.ElixirPrompts.DataStructures","type":"module"},{"doc":"","ref":"LangChain.ElixirPrompts.DataStructures.html#declare_map/2","title":"LangChain.ElixirPrompts.DataStructures.declare_map/2","type":"function"},{"doc":"An OpenAI implementation of the LangChain.EmbedderProtocol. Use this for embedding your docs for openai models by specifying the model_name in your LLM.","ref":"LangChain.Embedder.OpenAIProvider.html","title":"LangChain.Embedder.OpenAIProvider","type":"module"},{"doc":"","ref":"LangChain.EmbedderProtocol.html","title":"LangChain.EmbedderProtocol","type":"protocol"},{"doc":"Embed a list of documents","ref":"LangChain.EmbedderProtocol.html#embed_documents/2","title":"LangChain.EmbedderProtocol.embed_documents/2","type":"function"},{"doc":"Embed a single query","ref":"LangChain.EmbedderProtocol.html#embed_query/2","title":"LangChain.EmbedderProtocol.embed_query/2","type":"function"},{"doc":"","ref":"LangChain.EmbedderProtocol.html#t:t/0","title":"LangChain.EmbedderProtocol.t/0","type":"type"},{"doc":"Language Model GenServer","ref":"LangChain.LLM.html","title":"LangChain.LLM","type":"module"},{"doc":"","ref":"LangChain.LLM.html#call/2","title":"LangChain.LLM.call/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LangChain.LLM.html#child_spec/1","title":"LangChain.LLM.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"LangChain.LLM.html#init/1","title":"LangChain.LLM.init/1","type":"function"},{"doc":"","ref":"LangChain.LLM.html#start_link/1","title":"LangChain.LLM.start_link/1","type":"function"},{"doc":"","ref":"LangChain.LanguageModelProtocol.html","title":"LangChain.LanguageModelProtocol","type":"protocol"},{"doc":"","ref":"LangChain.LanguageModelProtocol.html#ask/2","title":"LangChain.LanguageModelProtocol.ask/2","type":"function"},{"doc":"","ref":"LangChain.LanguageModelProtocol.html#t:t/0","title":"LangChain.LanguageModelProtocol.t/0","type":"type"},{"doc":"A ProgramTemplate is a template that is filled out and fed to a programming language interpreter, compiler or VM. In most cases, this means we are passing Elixir code to the BEAM. This is an example of migrating data from the AI knowledge domain to the programming domain.","ref":"LangChain.ProgramTemplate.html","title":"LangChain.ProgramTemplate","type":"module"},{"doc":"","ref":"LangChain.ProgramTemplate.html#can_execute/1","title":"LangChain.ProgramTemplate.can_execute/1","type":"function"},{"doc":"","ref":"LangChain.ProgramTemplate.html#execute/1","title":"LangChain.ProgramTemplate.execute/1","type":"function"},{"doc":"","ref":"LangChain.ProgramTemplate.html#format/2","title":"LangChain.ProgramTemplate.format/2","type":"function"},{"doc":"","ref":"LangChain.ProgramTemplate.html#partial/2","title":"LangChain.ProgramTemplate.partial/2","type":"function"},{"doc":"a PromptTemplate is just a normal string template, you can pass it a set of values and it will interpolate them. You can also partially evaluate the template by calling the partial/2 function input_variables will contain the list of variables that still need to be specified to complete the template.","ref":"LangChain.PromptTemplate.html","title":"LangChain.PromptTemplate","type":"module"},{"doc":"converts to eex and then interpolates the values+partial_variables. (eex wants values and partial_variables to be specified as a map with atomic keys)","ref":"LangChain.PromptTemplate.html#format/2","title":"LangChain.PromptTemplate.format/2","type":"function"},{"doc":"partially apply the variables in 'partial' to the partial_variables and remove them from the input_variables","ref":"LangChain.PromptTemplate.html#partial/2","title":"LangChain.PromptTemplate.partial/2","type":"function"},{"doc":"Input Processing for the Bumblebee models","ref":"LangChain.Providers.Bumblebee.html","title":"LangChain.Providers.Bumblebee","type":"module"},{"doc":"","ref":"LangChain.Providers.Bumblebee.html#prepare_input/2","title":"LangChain.Providers.Bumblebee.prepare_input/2","type":"function"},{"doc":"When you want to use the Bumblebee API to embed documents. Embedding will transform documents into vectors of numbers that you can then feed into a neural network. The embedding provider must match the input size of the model and use the same encoding scheme.","ref":"LangChain.Providers.Bumblebee.Embedder.html","title":"LangChain.Providers.Bumblebee.Embedder","type":"module"},{"doc":"A module for interacting with Bumblebee language models, unlike the other providers Bumblebee runs models on your local hardware, see https://hexdocs.pm/bumblebee/Bumblebee.html When you load a model with Bumblebee it will download that model from the Huggingface API and cache it locally, so the first time you run a model it will take a while to download, but after that it will be much faster","ref":"LangChain.Providers.Bumblebee.LanguageModel.html","title":"LangChain.Providers.Bumblebee.LanguageModel","type":"module"},{"doc":"Goose AI is a for-pay provider for ML models https://goose.ai/docs/api/engines","ref":"LangChain.Providers.GooseAi.html","title":"LangChain.Providers.GooseAi","type":"module"},{"doc":"","ref":"LangChain.Providers.GooseAi.html#get_base/1","title":"LangChain.Providers.GooseAi.get_base/1","type":"function"},{"doc":"","ref":"LangChain.Providers.GooseAi.html#handle_response/2","title":"LangChain.Providers.GooseAi.handle_response/2","type":"function"},{"doc":"","ref":"LangChain.Providers.GooseAi.html#prepare_body/2","title":"LangChain.Providers.GooseAi.prepare_body/2","type":"function"},{"doc":"A module for interacting with GooseAi's API GooseAi is a host for ML models that take in any data and return any data, it can be used for LLM, image generation, image parsing, sound, etc","ref":"LangChain.Providers.GooseAi.LanguageModel.html","title":"LangChain.Providers.GooseAi.LanguageModel","type":"module"},{"doc":"shared configuration for Huggingface API calls","ref":"LangChain.Providers.Huggingface.html","title":"LangChain.Providers.Huggingface","type":"module"},{"doc":"used by all the HF api calls, get the base URL and HTTP headers for a given model","ref":"LangChain.Providers.Huggingface.html#get_base/1","title":"LangChain.Providers.Huggingface.get_base/1","type":"function"},{"doc":"","ref":"LangChain.Providers.Huggingface.html#get_base_audio/1","title":"LangChain.Providers.Huggingface.get_base_audio/1","type":"function"},{"doc":"","ref":"LangChain.Providers.Huggingface.html#get_template_body_for_action/1","title":"LangChain.Providers.Huggingface.get_template_body_for_action/1","type":"function"},{"doc":"","ref":"LangChain.Providers.Huggingface.html#handle_generation/1","title":"LangChain.Providers.Huggingface.handle_generation/1","type":"function"},{"doc":"finds the matching output format for this model/input and returns it as a string","ref":"LangChain.Providers.Huggingface.html#handle_response/2","title":"LangChain.Providers.Huggingface.handle_response/2","type":"function"},{"doc":"finds the right input format for this model/input and returns it as a http request body in string form","ref":"LangChain.Providers.Huggingface.html#prepare_input/2","title":"LangChain.Providers.Huggingface.prepare_input/2","type":"function"},{"doc":"Audio models with huggingface","ref":"LangChain.Providers.Huggingface.AudioModel.html","title":"LangChain.Providers.Huggingface.AudioModel","type":"module"},{"doc":"When you want to use the huggingface API to embed documents Embedding will transform documents into vectors of numbers that you can then feed into a neural network The embedding provider must match the input size of the model and use the same encoding scheme. Use Sentence Transformer modles like","ref":"LangChain.Providers.Huggingface.Embedder.html","title":"LangChain.Providers.Huggingface.Embedder","type":"module"},{"doc":"A module for interacting with Huggingface's API Huggingface is a host for ML models that take in any data and return any data, it can be used for LLM, image generation, image parsing, sound, etc","ref":"LangChain.Providers.Huggingface.LanguageModel.html","title":"LangChain.Providers.Huggingface.LanguageModel","type":"module"},{"doc":"NLP Cloud Provider https://nlpcloud.com/ This module is predominantly used for internal API handling @models %{ &quot;fast-gpt-j&quot; =&gt; &quot;A fast implementation of the GPT-J model.&quot;, &quot;finetuned-gpt-neox-20b&quot; =&gt; &quot;Fine-tuned GPT-NeoX 20B will work better than Fast GPT-J. It supports many non-English languages.&quot; , &quot;dolphin&quot; =&gt; &quot;Dolphin, an NLP Cloud in-house model, has a great accuracy at an affordable price. It supports many non-English languages.&quot; , &quot;chatdolphin&quot; =&gt; &quot;ChatDolphin, an NLP Cloud in-house model, has a great accuracy at an affordable price. It supports many non-English languages.&quot; }","ref":"LangChain.Providers.NlpCloud.html","title":"LangChain.Providers.NlpCloud","type":"module"},{"doc":"","ref":"LangChain.Providers.NlpCloud.html#get_base/1","title":"LangChain.Providers.NlpCloud.get_base/1","type":"function"},{"doc":"","ref":"LangChain.Providers.NlpCloud.html#handle_response/2","title":"LangChain.Providers.NlpCloud.handle_response/2","type":"function"},{"doc":"","ref":"LangChain.Providers.NlpCloud.html#prepare_body/2","title":"LangChain.Providers.NlpCloud.prepare_body/2","type":"function"},{"doc":"Used to report the price of a response from Replicate","ref":"LangChain.Providers.NlpCloud.html#report_price/1","title":"LangChain.Providers.NlpCloud.report_price/1","type":"function"},{"doc":"Language model implementation for NLP Cloud.","ref":"LangChain.Providers.NlpCloud.LanguageModel.html","title":"LangChain.Providers.NlpCloud.LanguageModel","type":"module"},{"doc":"OpenAI results return a body that will contain: 'usage': {'prompt_tokens': 56, 'completion_tokens': 31, 'total_tokens': 87} OpenAI Pricing Model Prompt Completion gpt-4 8K context $0.03 / 1K tokens $0.06 / 1K tokens 32K context $0.06 / 1K tokens $0.12 / 1K tokens gpt-3.5-turbo $0.002 / 1K tokens instructGPT (only models you can fine tune) Ada $0.0004 / 1K tokens Babbage $0.0005 / 1K tokens Curie $0.0020 / 1K tokens Davinci $0.0200 / 1K tokens Fine-tuning: Ada $0.0004 / 1K tokens $0.0016 / 1K tokens Babbage $0.0006 / 1K tokens $0.0024 / 1K tokens Curie $0.0030 / 1K tokens $0.0120 / 1K tokens Davinci $0.0300 / 1K tokens $0.1200 / 1K tokens embeddings Ada $0.0004 / 1K tokens","ref":"LangChain.Providers.OpenAI.html","title":"LangChain.Providers.OpenAI","type":"module"},{"doc":"","ref":"LangChain.Providers.OpenAI.html#get_pricing_structure/1","title":"LangChain.Providers.OpenAI.get_pricing_structure/1","type":"function"},{"doc":"Used to report the price of a response from OpenAI Needs to implement callbacks to a master pricing tracker","ref":"LangChain.Providers.OpenAI.html#report_price/2","title":"LangChain.Providers.OpenAI.report_price/2","type":"function"},{"doc":"A module for interacting with OpenAI's main language models","ref":"LangChain.Providers.OpenAI.LanguageModel.html","title":"LangChain.Providers.OpenAI.LanguageModel","type":"module"},{"doc":"Replicate's pricing structure is based on what hardware you use and how long you use it. More expensive hardware runs faster Replicate's Pricing Structure CPU $0.0002 per second (or, $0.012 per minute) 4x CPU 8GB RAM Nvidia T4 GPU $0.00055 per second (or, $0.033 per minute) 4x CPU 16GB GPU RAM 8GB RAM Nvidia A100 40GB GPU $0.0023 per second (or, $0.138 per minute)","ref":"LangChain.Providers.Replicate.html","title":"LangChain.Providers.Replicate","type":"module"},{"doc":"Used to report the price of a response from Replicate","ref":"LangChain.Providers.Replicate.html#report_price/1","title":"LangChain.Providers.Replicate.report_price/1","type":"function"},{"doc":"A module for interacting with Replicate's API Replicate is a host for ML models that take in any data and return any data, it can be used for LLM, image generation, image parsing, sound, etc","ref":"LangChain.Providers.Replicate.LanguageModel.html","title":"LangChain.Providers.Replicate.LanguageModel","type":"module"},{"doc":"","ref":"LangChain.Retriever.html","title":"LangChain.Retriever","type":"protocol"},{"doc":"Takes a string query and returns a list of relevant documents","ref":"LangChain.Retriever.html#get_relevant_documents/2","title":"LangChain.Retriever.get_relevant_documents/2","type":"function"},{"doc":"","ref":"LangChain.Retriever.html#t:t/0","title":"LangChain.Retriever.t/0","type":"type"},{"doc":"A filesystem implementation of the LangChain.Retriever protocol.","ref":"LangChain.Retriever.FileSystemProvider.html","title":"LangChain.Retriever.FileSystemProvider","type":"module"},{"doc":"Use this when you want to extract formatted data from natural-language text, ScrapeChain is basically a special form of QueryChain. ScrapeChain is a wrapper around a special type of Chain that requires 'input_schema' and 'input_text' in its input_variables and combines it with an output_parser. Once you define that chain, you can have the chain 'scrape' a text and return the formatted output in virtually any form.","ref":"LangChain.ScrapeChain.html","title":"LangChain.ScrapeChain","type":"module"},{"doc":"Creates a new ScrapeChain struct with the given chain, input_schema, and output_parser, you set up a scrapeChain with an input_schema and an output_parser, then you can ask it with whatever text you want. Example: create a chat to extract data: chat = Chat.add_prompt_templates(%Chat{}, [ %{ role : &quot;user&quot; , prompt : % PromptTemplate { template : &quot;Schema: &quot; &quot;&quot; &lt; % = input_schema % &gt; &quot;&quot;&quot; Text: &quot;&quot;&quot; &lt; % = input_text % &gt; &quot;&quot; Extract the data from Text according to Schema and return it in &lt; % = output_format % &gt; format . Format any datetime fields using ISO8601 standard . &quot; } } ]) create a ChainLink with the chat and parser function chain_link = %ChainLink{ name: &quot;schema_extractor&quot;, input: chat, output_parser: &amp;schema_parser/2 } chain = %Chain{links: [chain_link]} input_schema = &quot;{ name: String, age: Number, birthdate: Date }&quot; schema_chain = LangChain.ScrapeChain.new(chain, input_schema)","ref":"LangChain.ScrapeChain.html#new/3","title":"LangChain.ScrapeChain.new/3","type":"function"},{"doc":"default passthrough parser. 'result' will be a string so it is up to you to transform it into a native elixir structure or whatever you want.","ref":"LangChain.ScrapeChain.html#no_parse/1","title":"LangChain.ScrapeChain.no_parse/1","type":"function"},{"doc":"Executes the scrapechain and returns the parsed result, can be called against the schema you defined when you made the chain, or you can override that schema: result = LangChain.ScrapeChain.scrape(schema_chain, &quot;John Doe is 30 years old&quot;) # result will be %{ name: &quot;John Doe&quot;, age: 30, birthdate: &quot;1987-01-01&quot;} # override the default schema input_variables = %{ input_text : &quot;John Doe is 30 years old.&quot; , input_schema : &quot;{ firstName: String, lastName: String, age: Number, birthdate: Date }&quot; } alt_result = LangChain.ScrapeChain.scrape(schema_chain, input_variables) # alt_result will be %{ firstName: &quot;John&quot;, lastName: &quot;Doe&quot;, age: 30, birthdate: &quot;1987-01-01&quot;}","ref":"LangChain.ScrapeChain.html#scrape/3","title":"LangChain.ScrapeChain.scrape/3","type":"function"},{"doc":"A Scraper is a GenServer that scrapes natural language text and tries to turn it into some kind of structured data. It comes with a built in &quot;default_scraper&quot; that can generally extract data from text according to the schema you gave it. Examples: = Scraper.start_link() input_text = &quot;John Doe is 30 years old.&quot; {:ok, result} = Scraper.scrape(scraper_pid, input_text) = Scraper.scrape(scraper_pid, input_text, &quot;default_scraper&quot;, %{ output_format: &quot;XML&quot; }) = Scraper.scrape(scraper_pid, input_text, &quot;default_scraper&quot;, %{ input_schema: &quot;{ name: { first: String, last: String }, age: Number }&quot;, output_format: &quot;YAML&quot; })","ref":"LangChain.Scraper.html","title":"LangChain.Scraper","type":"module"},{"doc":"add your own custom scrape chain to the Scraper","ref":"LangChain.Scraper.html#add_scrape_chain/3","title":"LangChain.Scraper.add_scrape_chain/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LangChain.Scraper.html#child_spec/1","title":"LangChain.Scraper.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"LangChain.Scraper.html#init/1","title":"LangChain.Scraper.init/1","type":"function"},{"doc":"A default output parser that just returns the first response text as json","ref":"LangChain.Scraper.html#json_parser/2","title":"LangChain.Scraper.json_parser/2","type":"function"},{"doc":"Returns a list of all the scrape chains in the Scraper","ref":"LangChain.Scraper.html#list/1","title":"LangChain.Scraper.list/1","type":"function"},{"doc":"simple passthrough parser that just returns the result","ref":"LangChain.Scraper.html#output_parser/1","title":"LangChain.Scraper.output_parser/1","type":"function"},{"doc":"A default output parser that just returns the first response text","ref":"LangChain.Scraper.html#passthru_parser/2","title":"LangChain.Scraper.passthru_parser/2","type":"function"},{"doc":"scrape some text using the default scraper","ref":"LangChain.Scraper.html#scrape/5","title":"LangChain.Scraper.scrape/5","type":"function"},{"doc":"","ref":"LangChain.Scraper.html#start_link/1","title":"LangChain.Scraper.start_link/1","type":"function"},{"doc":"","ref":"LangChain.TextSplitter.html","title":"LangChain.TextSplitter","type":"protocol"},{"doc":"","ref":"LangChain.TextSplitter.html#split_strings/2","title":"LangChain.TextSplitter.split_strings/2","type":"function"},{"doc":"","ref":"LangChain.TextSplitter.html#split_text/2","title":"LangChain.TextSplitter.split_text/2","type":"function"},{"doc":"","ref":"LangChain.TextSplitter.html#t:t/0","title":"LangChain.TextSplitter.t/0","type":"type"},{"doc":"simple splitter that splits strings on a special character, like ' ' or '.'","ref":"LangChain.TextSplitter.Character.html","title":"LangChain.TextSplitter.Character","type":"module"},{"doc":"## VectorStore Genserver, provides all the services for storing and searching vectors You can specify a provider when you launch the GenServer in your Application tree, so you can have multiple VectorStore servers running in your application, each with a different provider. ## options: :provider -- the actual vector db provider you are using, must implement the VectorStore.Provider protocol :embed_documents -- optional function for embedding multiple docs presented as strings :embed_query -- optional function for embedding a single query when presented as a string","ref":"LangChain.VectorStore.html","title":"LangChain.VectorStore","type":"module"},{"doc":"","ref":"LangChain.VectorStore.html#add_documents/2","title":"LangChain.VectorStore.add_documents/2","type":"function"},{"doc":"Add a list of vectors to the vector store.","ref":"LangChain.VectorStore.html#add_vectors/2","title":"LangChain.VectorStore.add_vectors/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LangChain.VectorStore.html#child_spec/1","title":"LangChain.VectorStore.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"LangChain.VectorStore.html#init/1","title":"LangChain.VectorStore.init/1","type":"function"},{"doc":"load a vector store from a directory","ref":"LangChain.VectorStore.html#load/3","title":"LangChain.VectorStore.load/3","type":"function"},{"doc":"perform a similarity search on the vector store if query is a string it will be run through embed_query first","ref":"LangChain.VectorStore.html#similarity_search/4","title":"LangChain.VectorStore.similarity_search/4","type":"function"},{"doc":"perform a similarity search on the vector store and return score if query is a string it will be run through embed_query first","ref":"LangChain.VectorStore.html#similarity_search_with_score/4","title":"LangChain.VectorStore.similarity_search_with_score/4","type":"function"},{"doc":"","ref":"LangChain.VectorStore.html#start_link/1","title":"LangChain.VectorStore.start_link/1","type":"function"},{"doc":"A Pinecone implementation of the LangChain.VectorStore.Provider protocol. the 'config' argument just needs to be a struct with the config_name (ie :pinecone) for the specific db you want to use, this implementation will grab that config from config.exs for you. You can have multiple pinecone configs in config.exs, just make and multiple implementations of this module, each with a different config_name.","ref":"LangChain.VectorStore.PineconeProvider.html","title":"LangChain.VectorStore.PineconeProvider","type":"module"},{"doc":"","ref":"LangChain.VectorStore.Provider.html","title":"LangChain.VectorStore.Provider","type":"protocol"},{"doc":"add a list of vectors to the provider result is the number of vectors added","ref":"LangChain.VectorStore.Provider.html#add_vectors/2","title":"LangChain.VectorStore.Provider.add_vectors/2","type":"function"},{"doc":"load a vector store from a directory","ref":"LangChain.VectorStore.Provider.html#load/3","title":"LangChain.VectorStore.Provider.load/3","type":"function"},{"doc":"search for the top k most similar vectors to the query vector result is a simple list of vectors","ref":"LangChain.VectorStore.Provider.html#similarity_search/4","title":"LangChain.VectorStore.Provider.similarity_search/4","type":"function"},{"doc":"search for the top k most similar vectors to the query vector result is a list of %{ score: X.XX, vector: [....]} maps","ref":"LangChain.VectorStore.Provider.html#similarity_search_with_score/4","title":"LangChain.VectorStore.Provider.similarity_search_with_score/4","type":"function"},{"doc":"","ref":"LangChain.VectorStore.Provider.html#t:t/0","title":"LangChain.VectorStore.Provider.t/0","type":"type"},{"doc":"A Weaviate implementation of the LangChain.VectorStore.Provider protocol. the 'config' argument just needs to be a struct with the config_name (ie :weaviate) for the specific db you want to use, this implementation will grab that config from config.exs for you. You can have multiple weaviate configs in config.exs, just make and multiple implementations of this module, each with a different config_name.","ref":"LangChain.VectorStore.WeaviateProvider.html","title":"LangChain.VectorStore.WeaviateProvider","type":"module"},{"doc":"Documentation for LangchainEx .","ref":"LangchainEx.html","title":"LangchainEx","type":"module"},{"doc":"","ref":"LangchainEx.html#hello/0","title":"LangchainEx.hello/0","type":"function"},{"doc":"A mock implementation of the LangChain.VectorStore.Provider protocol for testing purposes.","ref":"MockVectorStoreProvider.html","title":"MockVectorStoreProvider","type":"module"},{"doc":"Use this when you want to ask a question using natural-language text, with no side-effects. QueryChain is a wrapper around a Chain that requires 'input_text' in its input_variables. Once you define that chain, you can 'ask' the QueryChain to run the chain and return the formatted output.","ref":"QueryChain.html","title":"QueryChain","type":"module"},{"doc":"Utility functions for memory","ref":"Utils.html","title":"Utils","type":"module"},{"doc":"","ref":"Utils.html#get_input_value/2","title":"Utils.get_input_value/2","type":"function"}]